﻿' Fig. 4.15: GradeBook.vb
' GradeBook class with a property that performs validation.
Public Class GradeBook
   Private courseNameValue As String ' course name for this GradeBook

   ' constructor initializes CourseName with String supplied as argument
   Public Sub New(ByVal name As String)
      CourseName = name ' validate and store course name
   End Sub ' New

   ' property that gets and sets the course name; the Set accessor
   ' ensures that the course name has at most 25 characters
   Public Property CourseName() As String
      Get ' retrieve courseNameValue
         Return courseNameValue
      End Get

      Set(ByVal value As String) ' set courseNameValue
         If value.Length <= 25 Then ' if value has 25 or fewer characters
            courseNameValue = value ' store the course name in the object
         End If

         If value.Length > 25 Then ' if value has more than 25 characters
            ' set courseNameValue to first 25 characters of value
            ' start at 0, length of 25
            courseNameValue = value.Substring(0, 25)

            Console.WriteLine( _
               "Name """ & value & """ exceeds maximum length (25).")
            Console.WriteLine( _
               "Limiting course name to first 25 characters." & vbCrLf)
         End If
      End Set
   End Property ' CourseName

   ' display a welcome message to the GradeBook user
   Public Sub DisplayMessage()
      ' this statement uses property CourseName to get the
      ' name of the course this GradeBook represents
      Console.WriteLine("Welcome to the grade book for " _
          & vbCrLf & CourseName & "!")
   End Sub ' DisplayMessage
End Class ' GradeBook

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************