' Fig. 6.9: GradeBook.vb
' GradeBook class uses Select...Case statement to count letter grades.
Public Class GradeBook
   Private courseNameValue As String ' name of course 
   Private total As Integer ' sum of grades                  
   Private gradeCounter As Integer ' number of grades entered
   Private aCount As Integer ' count of A grades             
   Private bCount As Integer ' count of B grades             
   Private cCount As Integer ' count of C grades             
   Private dCount As Integer ' count of D grades             
   Private fCount As Integer ' count of F grades
   Private perfectScoreCount As Integer ' count of perfect scores

   ' constructor initializes course name; 
   ' Integer instance variables are initialized to 0 by default
   Public Sub New(ByVal name As String)
      CourseName = name ' initializes CourseName
   End Sub ' New

   ' property that gets and sets the course name; the Set accessor
   ' ensures that the course name has at most 25 characters
   Public Property CourseName() As String
      Get ' retrieve courseNameValue
         Return courseNameValue
      End Get

      Set(ByVal value As String) ' set courseNameValue
         If value.Length <= 25 Then ' if value has 25 or fewer characters
            courseNameValue = value ' store the course name in the object
         Else ' if name has more than 25 characters
            ' set courseNameValue to first 25 characters of parameter name
            ' start at 0, length of 25
            courseNameValue = value.Substring(0, 25)

            Console.WriteLine( _
               "Course name (" & value & ") exceeds maximum length (25).")
            Console.WriteLine( _
               "Limiting course name to first 25 characters." & vbCrLf)
         End If
      End Set
   End Property ' CourseName

   ' display a welcome message to the GradeBook user
   Public Sub DisplayMessage()
      Console.WriteLine("Welcome to the grade book for " _
          & vbCrLf & CourseName & "!" & vbCrLf)
   End Sub ' DisplayMessage

   ' input arbitrary number of grades from user
   Public Sub InputGrades()
      Console.Write( _
         "Enter a grade in the range 0-100, negative value to quit: ")
      Dim grade As Integer = Console.ReadLine() ' input first grade

      ' loop until user enters a sentinel value
      While grade >= 0
         total += grade ' add grade to total
         gradeCounter += 1 ' increment number of grades

         ' call method to increment appropriate counter
         IncrementLetterGradeCounter(grade)

         ' input next grade
         Console.Write("Enter a grade in the range 0-100, " & _
            "negative value to quit: ")
         grade = Console.ReadLine()
      End While
   End Sub ' InputGrades

   ' add 1 to appropriate counter for specified grade
   Private Sub IncrementLetterGradeCounter(ByVal grade As Integer)
      Select Case grade ' determine which grade was entered
         Case 100 ' perfect score
            perfectScoreCount += 1 ' increment perfectScoreCount
            aCount += 1 ' increment aCount
         Case 90 To 99 ' grade was between 90 and 99
            aCount += 1 ' increment aCount
         Case 80 To 89 ' grade was between 80 and 89
            bCount += 1 ' increment bCount
         Case 70 To 79 ' grade was between 70 and 79
            cCount += 1 ' increment cCount
         Case 60 To 69 ' grade was between 60 and 69
            dCount += 1 ' increment dCount
         Case Else ' grade was less than 60
            fCount += 1 ' increment fCount
      End Select
   End Sub ' IncrementLetterGradeCounter

   ' display a report based on the grades entered by user 
   Public Sub DisplayGradeReport()
      Console.WriteLine(vbCrLf & "Grade Report:")

      ' if user entered at least one grade
      If (gradeCounter > 0) Then
         ' calculate average of all grades entered
         Dim average As Double = total / gradeCounter

         ' output summary of results
         Console.WriteLine("Total of the {0} grades entered is {1}", _
            gradeCounter, total)
         Console.WriteLine("Class average is {0:F2}", average)
         Console.WriteLine("Number of students who received each grade:")
         Console.WriteLine("A: " & aCount) ' display number of A grades
         Console.WriteLine("B: " & bCount) ' display number of B grades
         Console.WriteLine("C: " & cCount) ' display number of C grades
         Console.WriteLine("D: " & dCount) ' display number of D grades
         Console.WriteLine("F: " & fCount) ' display number of F grades
         Console.WriteLine(vbCrLf & "Number of students who received " & _
            "a perfect score: " & perfectScoreCount)
      Else ' no grades were entered, so output appropriate message
         Console.WriteLine("No grades were entered")
      End If
   End Sub ' DisplayGradeReport
End Class ' GradeBook

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************
