﻿' Fig. 7.17: RollTwelveDice.vb
' Rolling 12 dice with frequency chart.
Imports System.IO

Public Class FrmRollTwelveDice
   Dim randomObject As New Random() ' generate random number
   Dim ones As Integer ' count of die face 1
   Dim twos As Integer ' count of die face 2
   Dim threes As Integer ' count of die face 3
   Dim fours As Integer ' count of die face 4
   Dim fives As Integer ' count of die face 5
   Dim sixes As Integer ' count of die face 6

   ' display result of twelve rolls
   Private Sub btnRoll_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnRoll.Click

      ' assign random faces to 12 dice using DisplayDie
      DisplayDie(picDie1)
      DisplayDie(picDie2)
      DisplayDie(picDie3)
      DisplayDie(picDie4)
      DisplayDie(picDie5)
      DisplayDie(picDie6)
      DisplayDie(picDie7)
      DisplayDie(picDie8)
      DisplayDie(picDie9)
      DisplayDie(picDie10)
      DisplayDie(picDie11)
      DisplayDie(picDie12)

      Dim total As Integer = ones + twos + threes + fours + fives + sixes
      Dim output As String

      ' display frequencies of faces
      output = ("Face" & vbTab & vbTab & "Frequency" & vbTab & "Percent")
      output &= (vbCrLf & "1" & vbTab & vbTab & ones & _
         vbTab & vbTab & String.Format("{0:P}", ones / total))
      output &= (vbCrLf & "2" & vbTab & vbTab & twos & vbTab & _
         vbTab & String.Format("{0:P}", twos / total))
      output &= (vbCrLf & "3" & vbTab & vbTab & threes & vbTab & _
         vbTab & String.Format("{0:P}", threes / total))
      output &= (vbCrLf & "4" & vbTab & vbTab & fours & vbTab & _
         vbTab & String.Format("{0:P}", fours / total))
      output &= (vbCrLf & "5" & vbTab & vbTab & fives & vbTab & _
         vbTab & String.Format("{0:P}", fives / total))
      output &= (vbCrLf & "6" & vbTab & vbTab & sixes & vbTab & _
         vbTab & String.Format("{0:P}", sixes / total) & vbCrLf)
      txtDisplay.Text = output
   End Sub ' btnRoll_Click

   ' display a single die image
   Sub DisplayDie(ByVal picDie As PictureBox)
      Dim face As Integer = randomObject.Next(1, 7)

      picDie.Image = Image.FromFile(Directory.GetCurrentDirectory & _
         "\Images\die" & face & ".png")

      ' maintain count of die faces
      Select Case face
         Case 1 ' die face 1
            ones += 1
         Case 2 ' die face 2
            twos += 1
         Case 3 ' die face 3
            threes += 1
         Case 4 ' die face 4
            fours += 1
         Case 5 ' die face 5
            fives += 1
         Case 6 ' die face 6
            sixes += 1
      End Select
   End Sub ' DisplayDie
End Class ' FrmRollTwelveDice

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************