' Fig. 8.9: DeckOfCards.vb
' DeckOfCards class represents a deck of playing cards.
Public Class DeckOfCards
   Private deck As Card() ' array of Card objects
   Private currentCard As Integer ' index of next Card to be dealt
   Private Const NUMBER_OF_CARDS As Integer = 52 ' number of cards
   Private randomNumbers As Random ' random number generator

   ' constructor fills deck of Cards
   Public Sub New()
      Dim faces As String() = {"Ace", "Deuce", "Three", "Four", "Five", _
         "Six", "Seven", "Eight", "Nine", "Ten", "Jack", "Queen", "King"}
      Dim suits As String() = {"Hearts", "Diamonds", "Clubs", "Spades"}

      deck = New Card(NUMBER_OF_CARDS - 1) {} ' create array of Cards
      currentCard = 0 ' set currentCard so first Card dealt is deck(0)
      randomNumbers = New Random() ' create random number generator

      ' populate deck with Card objects
      For count As Integer = 0 To deck.GetUpperBound(0)
         deck(count) = New Card(faces(count Mod 13), suits(count \ 13))
      Next
   End Sub ' New

   ' shuffle deck of Cards with simple one-pass algorithm
   Public Sub Shuffle()
      ' after shuffling, dealing should start at deck(0) again
      currentCard = 0 ' reinitialize currentCard

      ' for each Card, pick another random Card and swap them
      For first As Integer = 0 To deck.GetUpperBound(0)
         ' select a random number between 0 and 51
         Dim second As Integer = randomNumbers.Next(NUMBER_OF_CARDS)

         ' swap current Card with randomly selected Card
         Dim temp As Card = deck(first)
         deck(first) = deck(second)
         deck(second) = temp
      Next
   End Sub ' Shuffle

   ' deal one Card
   Public Function DealCard() As Card
      ' determine whether Cards remain to be dealt
      If currentCard <= deck.GetUpperBound(0) Then
         Dim lastCard = currentCard ' store current card number
         currentCard += 1 ' increment current card number 
         Return deck(lastCard)
      Else
         Return Nothing
      End If
   End Function ' DealCard
End Class ' DeckOfCards

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************