' Fig. 8.22: ArrayReferenceTest.vb
' Testing the effects of passing array references using ByVal and ByRef.
Module ArrayReferenceTest
   Sub Main()
      ' declare array references
      Dim firstArray As Integer()
      Dim firstArrayCopy As Integer()

      ' allocate firstArray and copy its reference
      firstArray = New Integer() {1, 2, 3}
      firstArrayCopy = firstArray ' reference preceding array

      Console.WriteLine("Passing an array reference using ByVal.")
      Console.Write("Contents of firstArray before calling FirstDouble: ")

      ' print contents of firstArray
      For i As Integer = 0 To firstArray.GetUpperBound(0)
         Console.Write(firstArray(i) & " ")
      Next

      FirstDouble(firstArray) ' pass firstArray using ByVal
      Console.Write(vbCrLf & "Contents of firstArray after " & _
         "calling FirstDouble: ")

      ' print contents of firstArray
      For i As Integer = 0 To firstArray.GetUpperBound(0)
         Console.Write(firstArray(i) & " ")
      Next

      ' was reference to firstArray changed by FirstDouble?
      If firstArray Is firstArrayCopy Then
         Console.WriteLine(vbCrLf & "The references are equal.")
      Else
         Console.WriteLine(vbCrLf & "The references are not equal.")
      End If

      ' declare array references
      Dim secondArray As Integer()
      Dim secondArrayCopy As Integer()

      ' allocate secondArray and copy its reference
      secondArray = New Integer() {1, 2, 3}
      secondArrayCopy = secondArray

      Console.WriteLine(vbCrLf & "Passing an array " & _
         "reference using ByRef.")
      Console.Write("Contents of secondArray before " & _
         "calling SecondDouble: ")

      ' print contents of secondArray before method call
      For i As Integer = 0 To secondArray.GetUpperBound(0)
         Console.Write(secondArray(i) & " ")
      Next

      SecondDouble(secondArray) ' pass secondArray using ByRef
      Console.Write(vbCrLf & "Contents of secondArray " & _
         "after calling SecondDouble: ")

      ' print contents of secondArray after method call
      For i As Integer = 0 To secondArray.GetUpperBound(0)
         Console.Write(secondArray(i) & " ")
      Next

      ' was reference secondArray changed by SecondDouble
      If secondArray Is secondArrayCopy Then
         Console.WriteLine(vbCrLf & "The references are equal.")
      Else
         Console.WriteLine(vbCrLf & "The references are not equal.")
      End If
   End Sub ' Main

   ' method modifies elements of array and assigns 
   ' new reference (note ByVal)
   Sub FirstDouble(ByVal array As Integer())
      ' double each element value in callers array
      For i As Integer = 0 To array.GetUpperBound(0)
         array(i) *= 2 ' double the ith element
      Next

      ' create a new array and assign its reference to the variable array
      array = New Integer() {11, 12, 13}
   End Sub ' FirstDouble

   ' method modifies elements of array and assigns
   ' new reference (note ByRef)
   Sub SecondDouble(ByRef array As Integer())
      ' double each element value in callers array
      For i As Integer = 0 To array.GetUpperBound(0)
         array(i) *= 2 ' double the ith element
      Next

      ' create a new array and assign its reference to the variable array
      array = New Integer() {11, 12, 13} ' lose the 2, 4, 6 array
   End Sub ' SecondDouble
End Module ' ArrayReferenceTest

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************

