﻿' Fig. 10.9: BasePlusCommissionEmployee.vb
' BasePlusCommissionEmployee inherits from class CommissionEmployee.
Public Class BasePlusCommissionEmployee
   Inherits CommissionEmployee

   Private baseSalaryValue As Decimal ' base salary per week

   ' six-argument constructor
   Public Sub New(ByVal first As String, ByVal last As String, _
      ByVal ssn As String, ByVal sales As Decimal, _
      ByVal rate As Decimal, ByVal salary As Decimal)

      ' use MyBase to invoke CommissionEmployee constructor explicitly
      MyBase.New(first, last, ssn, sales, rate)
      BaseSalary = salary ' validate and store base salary
   End Sub ' New

   ' property BaseSalary
   Public Property BaseSalary() As Decimal
      Get
         Return baseSalaryValue
      End Get

      Set(ByVal salary As Decimal)
         If salary < 0.0 Then ' validate base salary
            baseSalaryValue = 0
         Else
            baseSalaryValue = salary
         End If
      End Set
   End Property ' BaseSalary

   ' calculate earnings
   Public Overrides Function CalculateEarnings() As Decimal
      ' not allowed: attempts to access private base class members 
      Return baseSalaryValue + (commissionRateValue * grossSalesValue)
   End Function ' CalculateEearnings

   ' return String representation of BasePlusCommissionEmployee object
   Public Overrides Function ToString() As String
      ' not allowed: attempts to access private base class members
      Return ("base-plus-commission employee: " & firstNameValue & " " & _
         lastNameValue & vbCrLf & "social security number: " & _
         socialSecurityNumberValue & vbCrLf & "gross sales: " & _
         String.Format("{0:C}", grossSalesValue) & vbCrLf & _
         "commission rate: " & String.Format("{0:F}", _
         commissionRateValue) & vbCrLf & "base salary: " & _
         String.Format("{0:C}", baseSalaryValue))
   End Function ' ToString
End Class ' BasePlusCommissionEmployee

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************