﻿' Fig. 11.12: Invoice.vb
' Invoice class implements IPayable.
Public Class Invoice
   Implements IPayable

   Private partNumberValue As String
   Private partDescriptionValue As String
   Private quantityValue As Integer
   Private pricePerItemValue As Decimal

   ' four-argument constructor
   Public Sub New(ByVal part As String, ByVal description As String, _
      ByVal count As Integer, ByVal price As Decimal)
      PartNumber = part
      PartDescription = description
      Quantity = count ' validate quantity
      PricePerItem = price ' validate price per item
   End Sub ' New

   ' property PartNumber
   Public Property PartNumber() As String
      Get
         Return partNumberValue
      End Get

      Set(ByVal part As String)
         partNumberValue = part
      End Set
   End Property ' PartNumber

   ' property PartDescription
   Public Property PartDescription() As String
      Get
         Return partDescriptionValue
      End Get

      Set(ByVal description As String)
         partDescriptionValue = description
      End Set
   End Property ' PartDescription

   ' property Quantity
   Public Property Quantity() As Integer
      Get
         Return quantityValue
      End Get

      Set(ByVal count As Integer)
         If count < 0 Then ' validate quantity
            quantityValue = 0
         Else
            quantityValue = count
         End If
      End Set
   End Property ' Quantity

   ' property PricePerItem
   Public Property PricePerItem() As Decimal
      Get
         Return pricePerItemValue
      End Get

      Set(ByVal price As Decimal)
         If price < 0 Then ' validate price
            pricePerItemValue = 0
         Else
            pricePerItemValue = price
         End If
      End Set
   End Property ' PricePerItem

   ' function required to carry out contract with interface IPayable 
   Public Function GetPaymentAmount() As Decimal _
      Implements IPayable.GetPaymentAmount
      Return Quantity * PricePerItem ' calculate total cost          
   End Function ' GetPaymentAmount                                   


   ' return String representation of Invoice object
   Public Overrides Function ToString() As String _
      Implements IPayable.ToString
      Return ("invoice:" & vbCrLf & "part number: " & PartNumber & _
         "(" & PartDescription & ")" & vbCrLf & "quantity: " & _
         Quantity & vbCrLf & _
         String.Format("price per item: {0:C}", PricePerItem))
   End Function ' ToString
End Class ' Invoice

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************