﻿' Fig. 11.14: SalariedEmployee.vb
' SalariedEmployee class inherits Employee, which implements IPayable.
Public Class SalariedEmployee
   Inherits Employee

   Private weeklySalaryValue As Decimal

   ' four-argument constructor
   Public Sub New(ByVal first As String, ByVal last As String, _
      ByVal ssn As String, ByVal salary As Decimal)
      MyBase.New(first, last, ssn) ' pass to Employee constructor
      WeeklySalary = salary ' validate and store salary
   End Sub ' New

   ' property WeeklySalary
   Public Property WeeklySalary() As Decimal
      Get
         Return weeklySalaryValue
      End Get

      Set(ByVal salary As Decimal)
         If salary < 0 Then ' validate salary
            weeklySalaryValue = 0
         Else
            weeklySalaryValue = salary
         End If
      End Set
   End Property ' WeeklySalary

   ' calculate earnings; implements interface IPayable method 
   ' GetPaymentAmount that was MustOverride in base class Employee
   Public Overrides Function GetPaymentAmount() As Decimal
      Return WeeklySalary
   End Function ' GetPaymentAmount                               

   ' return String representation of SalariedEmployee object        
   Public Overrides Function ToString() As String
      Return ("salaried employee: " & MyBase.ToString() & vbCrLf & _
         String.Format("weekly salary {0:C}", WeeklySalary))
   End Function ' ToString                                        
End Class ' SalariedEmployee

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************