' Fig. 13.28: FrmRadioButtonsTest.vb
' Using RadioButtons to set message window options.
Public Class FrmRadioButtonsTest
   ' create variables that store the user's choice of options
   Private iconType As MessageBoxIcon
   Private buttonType As MessageBoxButtons

   ' set button type to OK
   Private Sub radOk_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radOk.CheckedChanged
      buttonType = MessageBoxButtons.OK
   End Sub ' radOk_CheckedChanged

   ' set button type to OKCancel
   Private Sub radOkCancel_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radOkCancel.CheckedChanged
      buttonType = MessageBoxButtons.OKCancel
   End Sub ' radOkCancel_CheckedChanged

   ' set button type to AbortRetryIgnore
   Private Sub radAbortRetryIgnore_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radAbortRetryIgnore.CheckedChanged
      buttonType = MessageBoxButtons.AbortRetryIgnore
   End Sub ' radAbortRetryIgnore_CheckedChanged

   ' set button type to YesNoCancel
   Private Sub radYesNoCancel_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radYesNoCancel.CheckedChanged
      buttonType = MessageBoxButtons.YesNoCancel
   End Sub ' radYesNoCancel_CheckedChanged

   ' set button type to YesNo
   Private Sub radYesNo_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radYesNo.CheckedChanged
      buttonType = MessageBoxButtons.YesNo
   End Sub ' radYesNo_CheckedChanged

   ' set button type to RetryCancel
   Private Sub radRetryCancel_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radRetryCancel.CheckedChanged
      buttonType = MessageBoxButtons.RetryCancel
   End Sub ' radRetryCancel_CheckedChanged

   ' set icon type to Asterisk
   Private Sub radAsterisk_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radAsterisk.CheckedChanged
      iconType = MessageBoxIcon.Asterisk
   End Sub ' radAsterisk_CheckedChanged

   ' set icon type to Error
   Private Sub radError_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radError.CheckedChanged
      iconType = MessageBoxIcon.Error
   End Sub ' radError_CheckedChanged

   ' set icon type to Exclamation
   Private Sub radExclamation_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radExclamation.CheckedChanged
      iconType = MessageBoxIcon.Exclamation
   End Sub ' radExclamation_CheckedChanged

   ' set icon type to Hand
   Private Sub radHand_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radHand.CheckedChanged
      iconType = MessageBoxIcon.Hand
   End Sub ' radHand_CheckedChanged

   ' set icon type to Information    
   Private Sub radInformation_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radInformation.CheckedChanged
      iconType = MessageBoxIcon.Information
   End Sub ' radInformation_CheckedChanged

   ' set icon type to Question
   Private Sub radQuestion_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radQuestion.CheckedChanged
      iconType = MessageBoxIcon.Question
   End Sub ' radQuestion_CheckedChanged

   ' set icon type to Stop
   Private Sub radStop_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radStop.CheckedChanged
      iconType = MessageBoxIcon.Stop
   End Sub ' radStop_CheckedChanged

   ' set icon type to Warning
   Private Sub radWarning_CheckedChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles radWarning.CheckedChanged
      iconType = MessageBoxIcon.Warning
   End Sub ' radWarning_CheckedChanged

   ' display MessageBox and Button user pressed
   Private Sub btnDisplay_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnDisplay.Click
      ' display MessageBox and store
      ' the value of the Button that was pressed
      Dim result As DialogResult = MessageBox.Show( _
         "This is your custom MessageBox.", _
         "Custom MessageBox", buttonType, iconType, 0, 0)

      ' check to see which Button was pressed in the MessageBox
      ' change text displayed accordingly
      Select Case result
         Case Windows.Forms.DialogResult.OK
            lblDisplay.Text = "OK was pressed"
         Case Windows.Forms.DialogResult.Cancel
            lblDisplay.Text = "Cancel was pressed"
         Case Windows.Forms.DialogResult.Abort
            lblDisplay.Text = "Abort was pressed"
         Case Windows.Forms.DialogResult.Retry
            lblDisplay.Text = "Retry was pressed"
         Case Windows.Forms.DialogResult.Ignore
            lblDisplay.Text = "Ignore was pressed"
         Case Windows.Forms.DialogResult.Yes
            lblDisplay.Text = "Yes was pressed"
         Case Windows.Forms.DialogResult.No
            lblDisplay.Text = "No was pressed"
      End Select
   End Sub ' btnDisplay_Click
End Class ' FrmRadioButtonsTest

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************