' Fig. 14.31: FrmListViewTest.vb
' Displaying directories and their contents in ListView.
Imports System.IO

Public Class FrmListViewTest
   ' store current directory
   Private currentDirectory As String = Directory.GetCurrentDirectory()

   ' display files/subdirectories of current directory 
   ' (i.e., the one from which the application is executed)
   Private Sub FrmListViewTest_Load(ByVal sender As Object, _
      ByVal e As System.EventArgs) Handles Me.Load
      ' set Image list
      Dim folderImage As Image = Image.FromFile( _
         currentDirectory & "\images\folder.bmp")

      Dim fileImage As Image = Image.FromFile( _
         currentDirectory & "\images\file.bmp")

      fileFolder.Images.Add(folderImage)
      fileFolder.Images.Add(fileImage)

      ' load current directory into browserListView
      LoadFilesInDirectory(currentDirectory)
      lblDisplay.Text = currentDirectory
   End Sub ' FrmListViewTest_Load

   ' browse directory user clicked or go up one level
   Private Sub lvwBrowser_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles lvwBrowser.Click
      ' ensure an item is selected
      If lvwBrowser.SelectedItems.Count <> 0 Then
         ' if first item selected, go up one level
         If lvwBrowser.Items(0).Selected Then
            ' create DirectoryInfo object for directory
            Dim directoryObject As DirectoryInfo = _
               New DirectoryInfo(currentDirectory)

            ' if directory has parent, load it
            If directoryObject.Parent IsNot Nothing Then
               LoadFilesInDirectory(directoryObject.Parent.FullName)
               lblDisplay.Text = currentDirectory
            End If
         Else ' selected directory or file
            ' directory or file chosen
            Dim chosen As String = lvwBrowser.SelectedItems(0).Text

            ' if item selected is directory, load selected directory
            If Directory.Exists(currentDirectory & "\" & chosen) Then
               ' if currently in C:\, do not need '\'; otherwise we do
               If currentDirectory = "C:\" Then
                  LoadFilesInDirectory(currentDirectory & chosen)
               Else
                  LoadFilesInDirectory(currentDirectory & "\" & chosen)
               End If

               ' update displayLabel
               lblDisplay.Text = currentDirectory
            End If
         End If
      End If
   End Sub ' lvwBrowser_Click

   ' display files/subdirectories of current directory
   Private Sub LoadFilesInDirectory( _
      ByVal currentDirectoryValue As String)
      ' load directory information and display
      Try
         ' clear ListView and set first item
         lvwBrowser.Items.Clear()
         lvwBrowser.Items.Add("Go Up One Level")

         ' update current directory
         currentDirectory = currentDirectoryValue
         Dim newCurrentDirectory As DirectoryInfo = _
            New DirectoryInfo(currentDirectory)

         ' put files and directories into arrays
         Dim directoryArray As DirectoryInfo() = _
            newCurrentDirectory.GetDirectories()
         Dim fileArray As FileInfo() = newCurrentDirectory.GetFiles()

         ' add directory names to ListView
         For Each dir As DirectoryInfo In directoryArray
            ' add directory to ListView
            Dim newDirectoryItem As ListViewItem = _
               lvwBrowser.Items.Add(dir.Name)

            newDirectoryItem.ImageIndex = 0 ' set directory image
         Next

         ' add file names to ListView
         For Each file As FileInfo In fileArray
            ' add file to ListView
            Dim newFileItem As ListViewItem = _
               lvwBrowser.Items.Add(file.Name)

            newFileItem.ImageIndex = 1 ' set file image
         Next
      Catch e As UnauthorizedAccessException
         MessageBox.Show("Warning: Some files may not be " & _
            "visible due to permission settings", _
            "Attention", 0, MessageBoxIcon.Warning)
      End Try
   End Sub ' LoadFilesInDirectory
End Class ' FrmListViewTest

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************

