' Fig. 15.3: ThreadTester.vb
' Multiple threads printing at different intervals.
Imports System.Threading

Module ThreadTester
   Sub Main()
      ' Create and name each thread. Use MessagePrinter's
      ' Print method as argument to ThreadStart delegate.
      Dim printer1 As New MessagePrinter
      Dim thread1 As New Thread(New ThreadStart( _
         AddressOf printer1.Print))
      thread1.Name = "thread1"

      Dim printer2 As New MessagePrinter
      Dim thread2 As New Thread(New ThreadStart( _
         AddressOf printer2.Print))
      thread2.Name = "thread2"

      Dim printer3 As New MessagePrinter
      Dim thread3 As New Thread(New ThreadStart( _
         AddressOf printer3.Print))
      thread3.Name = "thread3"

      Console.WriteLine("Starting threads in Main")

      ' call each thread's Start method to place each 
      ' thread in Running state
      thread1.Start()
      thread2.Start()
      thread3.Start()

      Console.WriteLine("Threads started, Main ends" & vbCrLf)
   End Sub ' Main

   ' Print method of this class used to control threads
   Class MessagePrinter
      Private sleepTime As Integer
      Private Shared random As New Random

      ' constructor to initialize a MessagePrinter object
      Sub New()
         ' pick random sleep time between 0 and 5 seconds
         sleepTime = random.Next(5001)
      End Sub ' New

      ' method Print controls thread that prints messages
      Public Sub Print()
         ' obtain reference to currently executing thread
         Dim current As Thread = Thread.CurrentThread

         ' indicate that thread is going to sleep
         Console.WriteLine(current.Name & " going to sleep for " & _
            sleepTime & " milliseconds")
         Thread.Sleep(sleepTime) ' sleep for sleepTime milliseconds

         ' display the thread's name
         Console.WriteLine(current.Name + " done sleeping")
      End Sub ' Print
   End Class ' MessagePrinter
End Module ' ThreadTester

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************