' Fig. 15.12: CircularBufferTest.vb
' Implementing the producer/consumer relationship with a circular buffer.
Imports System.Threading

Module CircularBufferTest
   ' create producer and consumer threads and start them
   Sub Main()
      ' create shared object used by threads
      Dim sharedBuffer As New CircularBuffer()

      ' Random object used by each thread
      Dim random As New Random()

      ' display shared state before producer and consumer 
      ' threads begin execution
      sharedBuffer.CreateStateOutput()

      ' create Producer and Consumer objects
      Dim producer As New Producer(sharedBuffer, random)
      Dim consumer As New Consumer(sharedBuffer, random)

      ' create threads for producer and consumer and set 
      ' delegates for each thread
      Dim producerThread As New Thread(New ThreadStart( _
         AddressOf producer.Produce))
      producerThread.Name = "Producer"

      Dim consumerThread As New Thread(New ThreadStart( _
         AddressOf consumer.Consume))
      consumerThread.Name = "Consumer"

      ' start each thread
      producerThread.Start()
      consumerThread.Start()
   End Sub ' Main
End Module ' CircularBufferTest

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************