' Fig. 22.29: FrmMathTutor.vb
' Math tutoring program using Web service to generate random equations.
Public Class FrmMathTutor
   Private operation As String = "+"
   Private level As Integer = 1
   Private currentEquation As localhost.Equation
   Private generator As New localhost.EquationGeneratorWebService()

   ' generates a new equation when user clicks button
   Private Sub btnGenerate_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnGenerate.Click
      ' generate equation using current operation and level
      currentEquation = generator.GenerateEquation(operation, level)

      ' display left-hand side of equation
      lblQuestion.Text = currentEquation.LeftHandSide

      btnOK.Enabled = True
      txtAnswer.Enabled = True
   End Sub ' btnGenerate_Click

   ' check user's answer
   Private Sub btnOK_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnOK.Click
      ' determine correct result from Equation object
      Dim answer As Integer = currentEquation.Result

      If txtAnswer.Text <> "" Then
         ' get user's answer
         Dim userAnswer As Integer = Int32.Parse(txtAnswer.Text)

         ' determine whether user's answer is correct
         If answer = userAnswer Then
            lblQuestion.Text = "" ' clear question
            txtAnswer.Text = "" ' clear answer
            btnOK.Enabled = False ' disable OK button
            MessageBox.Show("Correct! Good job!")
         Else
            MessageBox.Show("Incorrect. Try again.")
         End If
      End If
   End Sub ' btnOK_Click

   ' set the operation to addition
   Private Sub radAddition_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radAddition.CheckedChanged
      operation = "+"
      btnGenerate.Text = "Generate " & radAddition.Text & " Example"
   End Sub ' radAddition_CheckedChanged

   ' set the operation to subtraction
   Private Sub radSubtraction_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radSubtraction.CheckedChanged
      operation = "-"
      btnGenerate.Text = "Generate " & radSubtraction.Text & " Example"
   End Sub ' radSubtraction_CheckedChanged

   ' set the operation to multiplication
   Private Sub radMultiplication_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radMultiplication.CheckedChanged
      operation = "*"
      btnGenerate.Text = "Generate " & radMultiplication.Text & " Example"
   End Sub ' radMultiplication_CheckedChanged

   ' set difficulty level to 1
   Private Sub radLevelOne_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radLevelOne.CheckedChanged
      level = 1
   End Sub ' radLevelOne_CheckedChanged

   ' set difficulty level to 2
   Private Sub radLevelTwo_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radLevelTwo.CheckedChanged
      level = 2
   End Sub ' radLevelTwo_CheckedChanged

   ' set difficulty level to 3
   Private Sub radLevelThree_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radLevelThree.CheckedChanged
      level = 3
   End Sub ' radLevelThree_CheckedChanged
End Class ' FrmMathTutor

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               * 
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
