' Fig. 23.3: FrmPacketServer.vb
' Set up a server that will receive packets from a
' client and send the packets back to the client.
Imports System.Net
Imports System.Net.Sockets
Imports System.Threading

Public Class FrmPacketServer
   Private client As UdpClient
   Private receivePoint As IPEndPoint

   ' initialize variables and thread for receiving packets
   Private Sub FrmPacketServer_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

      client = New UdpClient(50000)
      receivePoint = New IPEndPoint(New IPAddress(0), 0)
      Dim readThread As New Thread( _
         New ThreadStart(AddressOf WaitForPackets))
      readThread.Start()
   End Sub ' FrmPacketServer_Load

   ' shut down the server
   Private Sub FrmPacketServer_FormClosing( _
      ByVal sender As System.Object, _
      ByVal e As System.Windows.Forms.FormClosingEventArgs) _
      Handles MyBase.FormClosing

      System.Environment.Exit(System.Environment.ExitCode)
   End Sub ' FrmPacketServer_FormClosing

   ' Delegate that allows method DisplayMessage to be called
   ' in the thread that creates and maintains the GUI       
   Private Delegate Sub DisplayDelegate(ByVal message As String)

   ' method DisplayMessage sets txtDisplay's Text property
   ' in a thread-safe manner
   Private Sub DisplayMessage(ByVal message As String)
      ' if modifying txtDisplay is not thread safe
      If txtDisplay.InvokeRequired Then
         ' use inherited method Invoke to execute DisplayMessage
         ' via a Delegate                                       
         Invoke(New DisplayDelegate(AddressOf DisplayMessage), _
            New Object() {message})
         ' OK to modify txtDisplay in current thread
      Else
         txtDisplay.Text &= message
      End If
   End Sub ' DisplayMessage

   ' wait for a packet to arrive
   Public Sub WaitForPackets()
      While True
         ' set up packet
         Dim data As Byte() = client.Receive(receivePoint)
         DisplayMessage( _
            vbCrLf & "Packet received:" & vbCrLf & "Length: " & _
            data.Length & vbCrLf & "Contents: " & _
            System.Text.Encoding.ASCII.GetString(data))

         ' echo information from packet back to client
         DisplayMessage(vbCrLf & vbCrLf & "Echo data back to client...")
         client.Send(data, data.Length, receivePoint)
         DisplayMessage(vbCrLf & "Packet sent" & vbCrLf)
      End While
   End Sub ' WaitForPackets
End Class ' FrmPacketServer

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************