' Fig. 23.9: CityWeather.vb
' Class representing the weather information for one city.

<Serializable()> _
Public Class CityWeather : Implements IComparable
   Private cityNameValue As String
   Private descriptionValue As String
   Private temperatureValue As String

   Public Sub New(ByVal city As String, ByVal information As String, _
      ByVal degrees As String)

      cityNameValue = city
      descriptionValue = information
      temperatureValue = degrees
   End Sub ' New

   ' read-only property that gets city's name
   Public ReadOnly Property CityName() As String
      Get
         Return cityNameValue
      End Get
   End Property ' CityName

   ' read-only property that gets city's weather description
   Public ReadOnly Property Description() As String
      Get
         Return descriptionValue
      End Get
   End Property ' Description

   ' read-only property that gets city's temperature
   Public ReadOnly Property Temperature() As String
      Get
         Return temperatureValue
      End Get
   End Property ' Temperature

   ' implementation of CompareTo method for alphabetizing
   Public Function CompareTo(ByVal obj As Object) _
      As Integer Implements System.IComparable.CompareTo

      Return String.Compare(CityName, CType(obj, CityWeather).CityName)
   End Function ' CompareTo

   ' return string representation of this CityWeather object
   ' (used to display the weather report on the server console)
   Public Overrides Function ToString() As String
      Return CityName & " | " & Temperature & " | " & Description
   End Function ' ToString
End Class ' CityWeather

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************